apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: sign-image-cosign
  namespace: {{ buildns }}
spec:
  params:
{% if k8s_flavor != 'openshift' %}
  - default: ""
    name: dockeruser
    type: string
  - default: ""
    name: dockersecret
    type: string
{% endif %}
  - name: dstimage
    description: Image to Sign
    type: string
  - name: IMAGE_DIGEST
    description: Reference of the Image we want to Sign
    type: string
    default: latest
  - default: "true"
    description: Verify the TLS on the registry endpoint (for push/pull to a non-TLS registry)
    name: tlsverify
    type: string
  steps:
  - args:
    - -c
    - |
        echo "==== Signing $(params.dstimage) ===="
        IMAGE_ROOT=`echo $(params.dstimage) | sed 's|:[^:]*$||'`
        if echo "$(params.IMAGE_DIGEST)" | grep ^sha >/dev/null; then
            IMGADDR="$IMAGE_ROOT@$(params.IMAGE_DIGEST)"
        else
            IMGADDR="$IMAGE_ROOT:$(params.IMAGE_DIGEST)"
        fi
        echo "=> Resolved to $IMGADDR"
{% if k8s_flavor == 'openshift' %}
        USERNAME={{ pipeline_sa }}
        PASSWORD="$(cat /var/run/secrets/kubernetes.io/serviceaccount/token)"
{% else %}
        PASSWORD=$(params.dockersecret)
        USERNAME=$(params.dockeruser)
{% endif %}
        if test "$USERNAME" -a "$PASSWORD"; then
            REGISTRY_HOST=$(echo $(params.dstimage) | cut -d/ -f1)
            if test "$(params.tlsverify)" = true; then
                if ! podman login -u $USERNAME -p $PASSWORD $REGISTRY_HOST; then
                    echo "Failed logging into registry $REGISTRY_HOST"
                    exit 1
                fi
            elif ! podman login --tls-verify=false -u $USERNAME -p $PASSWORD $REGISTRY_HOST; then
                echo "Failed logging into insecure registry $REGISTRY_HOST"
                exit 1
            fi
        fi
        if test -s /secret/cosign.key -a -s /secret/passphrase; then
            if ! cat /secret/passphrase | cosign sign --key /secret/cosign.key "$IMGADDR"; then
                echo "Failed Signing $IMGADDR"
                exit 1
            else
                echo "Successfully signed $IMGADDR"
            fi
        else
            echo "Did not find cosign private key and passphrase - $IMGADDR will not be signed"
        fi
        exit 0
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='jkagsign'].image"))[0] }}
    name: sign-image
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_sign_cpu_limit }}"
        memory: {{ tekton_sign_memory_limit }}
      requests:
        cpu: "{{ tekton_sign_cpu_request }}"
        memory: {{ tekton_sign_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
      privileged: true
{% endif %}
  workspaces:
  - name: sigsecret
    mountPath: /secret
    optional: true
